--- old/usr/src/cmd/dtrace/Makefile.com	2014-01-14 20:11:58.137350540 -0500
+++ new/usr/src/cmd/dtrace/Makefile.com	2014-01-14 20:11:58.169055745 -0500
@@ -29,6 +29,7 @@
 SRCS = $(OBJS:%.o=../%.c)
 
 include ../../Makefile.cmd
+include ../../Makefile.ctf
 
 CFLAGS += $(CCVERBOSE)
 CFLAGS64 += $(CCVERBOSE)
@@ -53,5 +54,6 @@
 
 %.o: ../%.c
 	$(COMPILE.c) $<
+	$(POST_PROCESS_O)
 
 include ../../Makefile.targ
--- old/usr/src/cmd/dtrace/dtrace.c	2014-01-14 20:11:58.653874277 -0500
+++ new/usr/src/cmd/dtrace/dtrace.c	2014-01-14 20:11:58.669937043 -0500
@@ -25,6 +25,7 @@
  */
 /*
  * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
  */
 
 #include <sys/types.h>
@@ -488,6 +489,7 @@
 print_probe_info(const dtrace_probeinfo_t *p)
 {
 	char buf[BUFSIZ];
+	char *user;
 	int i;
 
 	oprintf("\n\tProbe Description Attributes\n");
@@ -511,10 +513,14 @@
 	oprintf("\n\tArgument Types\n");
 
 	for (i = 0; i < p->dtp_argc; i++) {
+		if (p->dtp_argv[i].dtt_flags & DTT_FL_USER)
+			user = "userland ";
+		else
+			user = "";
 		if (ctf_type_name(p->dtp_argv[i].dtt_ctfp,
 		    p->dtp_argv[i].dtt_type, buf, sizeof (buf)) == NULL)
 			(void) strlcpy(buf, "(unknown)", sizeof (buf));
-		oprintf("\t\targs[%d]: %s\n", i, buf);
+		oprintf("\t\targs[%d]: %s%s\n", i, user, buf);
 	}
 
 	if (p->dtp_argc == 0)
--- old/usr/src/cmd/dtrace/test/tst/common/Makefile	2014-01-14 20:11:59.303662427 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/Makefile	2014-01-14 20:11:59.318674928 -0500
@@ -26,7 +26,12 @@
 
 #
 # Copyright (c) 2012 by Delphix. All rights reserved.
-# Copyright (c) 2012, Joyent, Inc. All rights reserved.
+# Copyright (c) 2013, Joyent, Inc. All rights reserved.
+#
+
+#
+# WARNING: Do not include Makefile.ctf here. That will cause tests to
+# break.
 #
 
 include $(SRC)/Makefile.master
@@ -85,6 +90,38 @@
 	$(LINK.c) -o json/tst.usdt.exe json/tst.usdt.o json/usdt.o $(LDLIBS)
 	$(POST_PROCESS) ; $(STRIP_STABS)
 
+#
+# Tests that use the next three programs rely on the binaries having
+# valid CTF data.
+#
+uctf/tst.aouttype.exe: uctf/tst.aouttype.c
+	$(COMPILE.c) $(CTF_FLAGS) -o uctf/tst.aouttype.o uctf/tst.aouttype.c
+	$(CTFCONVERT) -i -L VERSION uctf/tst.aouttype.o
+	$(LINK.c) -o uctf/tst.aouttype.exe uctf/tst.aouttype.o $(LDLIBS)
+	$(CTFMERGE) -L VERSION -o $@ uctf/tst.aouttype.o
+	$(POST_PROCESS) ; $(STRIP_STABS)
+
+uctf/tst.chasestrings.exe: uctf/tst.chasestrings.c
+	$(COMPILE.c) $(CTF_FLAGS) -o uctf/tst.chasestrings.o uctf/tst.chasestrings.c
+	$(CTFCONVERT) -i -L VERSION uctf/tst.chasestrings.o
+	$(LINK.c) -o uctf/tst.chasestrings.exe uctf/tst.chasestrings.o $(LDLIBS)
+	$(CTFMERGE) -L VERSION -o $@ uctf/tst.chasestrings.o
+	$(POST_PROCESS) ; $(STRIP_STABS)
+
+uctf/tst.printtype.exe: uctf/tst.printtype.c
+	$(COMPILE.c) $(CTF_FLAGS) -o uctf/tst.printtype.o uctf/tst.printtype.c
+	$(CTFCONVERT) -i -L VERSION uctf/tst.printtype.o
+	$(LINK.c) -o uctf/tst.printtype.exe uctf/tst.printtype.o $(LDLIBS)
+	$(CTFMERGE) -L VERSION -o $@ uctf/tst.printtype.o
+	$(POST_PROCESS) ; $(STRIP_STABS)
+
+#
+# This program should never have any ctf data in it.
+#
+uctf/tst.libtype.exe:
+	$(LINK.c) -o uctf/tst.libtype.exe uctf/tst.libtype.c $(LDLIBS)
+	$(POST_PROCESS) ; $(STRIP_STABS)
+
 usdt/tst.args.exe: usdt/tst.args.o usdt/args.o
 	$(LINK.c) -o usdt/tst.args.exe usdt/tst.args.o usdt/args.o $(LDLIBS)
 	$(POST_PROCESS) ; $(STRIP_STABS)
--- old/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex1.ksh	2014-01-14 20:11:59.810005289 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex1.ksh	2014-01-14 20:11:59.841851923 -0500
@@ -45,10 +45,10 @@
 all: main
 
 main: main.o
-	gcc -o main main.o
+	gcc -m32 -o main main.o
 
 main.o: main.c
-	gcc -c main.c
+	gcc -m32 -c main.c
 EOF
 
 cat > main.c <<EOF
--- old/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex2.ksh	2014-01-14 20:12:00.615764387 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex2.ksh	2014-01-14 20:12:00.829549486 -0500
@@ -45,16 +45,16 @@
 all: main altlib.so
 
 main: main.o
-	gcc -o main main.o
+	gcc -m32 -o main main.o
 
 main.o: main.c
-	gcc -c main.c
+	gcc -m32 -c main.c
 
 altlib.so: altlib.o
-	gcc -shared -o altlib.so altlib.o -lc
+	gcc -m32 -shared -o altlib.so altlib.o -lc
 
 altlib.o: altlib.c
-	gcc -c altlib.c
+	gcc -m32 -fPIC -c altlib.c
 EOF
 
 cat > altlib.c <<EOF
--- old/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex3.ksh	2014-01-14 20:12:01.553133686 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex3.ksh	2014-01-14 20:12:01.568520863 -0500
@@ -46,10 +46,10 @@
 all: main
 
 main: main.o prov.o
-	gcc -o main main.o prov.o
+	gcc -m32 -o main main.o prov.o
 
 main.o: main.c prov.h
-	gcc -c main.c
+	gcc -m32 -c main.c
 
 prov.h: prov.d
 	$dtrace -h -s prov.d
--- old/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex4.ksh	2014-01-14 20:12:02.006337952 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/pid/tst.provregex4.ksh	2014-01-14 20:12:02.024679544 -0500
@@ -46,10 +46,10 @@
 all: main altlib.so
 
 main: main.o provmain.o
-	gcc -o main main.o provmain.o
+	gcc -m32 -o main main.o provmain.o
 
 main.o: main.c prov.h
-	gcc -c main.c
+	gcc -m32 -c main.c
 
 prov.h: prov.d
 	$dtrace -h -s prov.d
@@ -58,10 +58,10 @@
 	$dtrace -G -32 -o provmain.o -s prov.d main.o
 
 altlib.so: altlib.o provalt.o
-	gcc -shared -o altlib.so altlib.o provalt.o -lc
+	gcc -m32 -shared -o altlib.so altlib.o provalt.o -lc
 
 altlib.o: altlib.c prov.h
-	gcc -c altlib.c
+	gcc -m32 -c altlib.c
 
 provalt.o: prov.d altlib.o
 	$dtrace -G -32 -o provalt.o -s prov.d altlib.o
--- old/usr/src/cmd/dtrace/test/tst/common/printa/tst.largeusersym.ksh	2014-01-14 20:12:02.602910818 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/printa/tst.largeusersym.ksh	2014-01-14 20:12:02.637438043 -0500
@@ -50,7 +50,7 @@
 }
 EOF
 
-gcc -o test test.c
+gcc -m32 -o test test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
--- /dev/null	2014-01-14 20:12:03.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/err.invalidpid.d	2014-01-14 20:12:03.178127654 -0500
@@ -0,0 +1,21 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright (c) 2013 Joyent, Inc.  All rights reserved.
+ */
+
+#pragma D option quiet
+
+BEGIN
+{
+	trace((pidfoo`int)0);
+}
--- /dev/null	2014-01-14 20:12:03.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/err.invalidpid2.d	2014-01-14 20:12:03.496420120 -0500
@@ -0,0 +1,21 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright (c) 2013 Joyent, Inc.  All rights reserved.
+ */
+
+#pragma D option quiet
+
+BEGIN
+{
+	trace((pid8foo`int)0);
+}
--- /dev/null	2014-01-14 20:12:03.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/err.invalidpid3.d	2014-01-14 20:12:03.713282791 -0500
@@ -0,0 +1,21 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright (c) 2013 Joyent, Inc.  All rights reserved.
+ */
+
+#pragma D option quiet
+
+BEGIN
+{
+	trace((pid0`int)0);
+}
--- /dev/null	2014-01-14 20:12:03.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/err.invalidtype.ksh	2014-01-14 20:12:03.930629250 -0500
@@ -0,0 +1,34 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# While it's hard to be completely certain that a type of the name we want
+# doesn't exist, we're going to try to pick a name which is rather unique.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="season_8_mountain_of_madness_t"
+pid=$$
+
+rc=`$dtrace -n "BEGIN{ trace(pid$pid`$t)0); }"`
+
+exit $rc
--- /dev/null	2014-01-14 20:12:04.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/err.invalidtype2.ksh	2014-01-14 20:12:04.153895710 -0500
@@ -0,0 +1,35 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# While it's hard to be completely certain that a type of the name we want
+# doesn't exist, we're going to try to pick a name which is rather
+# unique. This time we're also going to use the pid$target alias.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="season_8_mountain_of_madness_t"
+pid=$$
+
+rc=`$dtrace -n "BEGIN{ trace(pid`$t)0); }"` -p $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:04.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/err.user64mode.ksh	2014-01-14 20:12:04.376241190 -0500
@@ -0,0 +1,90 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# This test is purposefully using a 64-bit DTrace and thus 64-bit types
+# when compared with a 32-bit process. This test uses the userland
+# keyword and so the implicit copyin should access illegal memory and
+# thus exit.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="zelda_info_t"
+exe="tst.chasestrings.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -64 -qs /dev/stdin <<EOF
+typedef struct info {
+        char    *zi_gamename;
+        int     zi_ndungeons;
+        char    *zi_villain;
+        int     zi_haszelda;
+} info_t;
+
+pid$pid::has_princess:entry
+/next == 0/
+{
+	this->t = (userland info_t *)arg0;
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(this->t->zi_gamename), this->t->zi_ndungeons,
+	    stringof(this->t->zi_villain), this->t->zi_haszelda);
+	next = 1;
+}
+
+pid$pid::has_dungeons:entry
+/next == 1/
+{
+	this->t = (userland info_t *)arg0;
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(this->t->zi_gamename), this->t->zi_ndungeons,
+	    stringof(this->t->zi_villain), this->t->zi_haszelda);
+	next = 2;
+}
+
+pid$pid::has_villain:entry
+/next == 2/
+{
+	this->t = (userland info_t *)arg0;
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(this->t->zi_gamename), this->t->zi_ndungeons,
+	    stringof(this->t->zi_villain), this->t->zi_haszelda);
+	exit(0);
+}
+
+ERROR
+{
+	exit(1);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:04.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.aouttype.c	2014-01-14 20:12:04.598224037 -0500
@@ -0,0 +1,46 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 (c) Joyent, Inc. All rights reserved.
+ */
+
+/*
+ * This test tries to make sure that we have CTF data for a type that only this
+ * binary would reasonably have. In this case, the
+ * season_7_lisa_the_vegetarian_t.
+ */
+#include <unistd.h>
+
+typedef struct season_7_lisa_the_vegetarian {
+	int fr_salad;
+} season_7_lisa_the_vegetarian_t;
+
+int
+sleeper(season_7_lisa_the_vegetarian_t *lp)
+{
+	for (;;) {
+		sleep(lp->fr_salad);
+	}
+	/*NOTREACHED*/
+	return (0);
+}
+
+int
+main(void)
+{
+	season_7_lisa_the_vegetarian_t l;
+	l.fr_salad = 100;
+
+	sleeper(&l);
+
+	return (0);
+}
--- /dev/null	2014-01-14 20:12:04.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.aouttype.ksh	2014-01-14 20:12:04.820219628 -0500
@@ -0,0 +1,44 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# Lookup a type that is inside a.out.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="season_7_lisa_the_vegetrian_t *"
+exe="tst.aouttype.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+rc=`$dtrace -n "BEGIN{ trace((pid$pid\`$t)0); exit(0); }"`
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:05.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.chasestrings.c	2014-01-14 20:12:05.070653554 -0500
@@ -0,0 +1,79 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 (c) Joyent, Inc. All rights reserved.
+ */
+
+/*
+ * This test takes data from the current binary which is basically running in a
+ * loop between two functions and our goal is to have two unique types that they
+ * contain which we can print.
+ */
+
+#include <unistd.h>
+
+typedef struct zelda_info {
+	char	*zi_gamename;
+	int	zi_ndungeons;
+	char	*zi_villain;
+	int	zi_haszelda;
+} zelda_info_t;
+
+static int
+has_princess(zelda_info_t *z)
+{
+	return (z->zi_haszelda);
+}
+
+static int
+has_dungeons(zelda_info_t *z)
+{
+	return (z->zi_ndungeons != 0);
+}
+
+static const char *
+has_villain(zelda_info_t *z)
+{
+	return (z->zi_villain);
+}
+
+int
+main(void)
+{
+	zelda_info_t oot;
+	zelda_info_t la;
+	zelda_info_t lttp;
+
+	oot.zi_gamename = "Ocarina of Time";
+	oot.zi_ndungeons = 10;
+	oot.zi_villain = "Ganondorf";
+	oot.zi_haszelda = 1;
+
+	la.zi_gamename = "Link's Awakening";
+	la.zi_ndungeons = 9;
+	la.zi_villain = "Nightmare";
+	la.zi_haszelda = 0;
+
+	lttp.zi_gamename = "A Link to the Past";
+	lttp.zi_ndungeons = 12;
+	lttp.zi_villain = "Ganon";
+	lttp.zi_haszelda = 1;
+
+	for (;;) {
+		(void) has_princess(&oot);
+		(void) has_dungeons(&la);
+		(void) has_villain(&lttp);
+		sleep(1);
+	}
+
+	return (0);
+}
--- /dev/null	2014-01-14 20:12:05.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.chasestrings.ksh	2014-01-14 20:12:05.411999639 -0500
@@ -0,0 +1,76 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# This test is checking that we can read members and that pointers inside
+# members point to valid data that is intelligible, eg. strings.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="zelda_info_t"
+exe="tst.chasestrings.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -qs /dev/stdin <<EOF
+pid$pid::has_princess:entry
+/next == 0/
+{
+	this->t = (pid$pid\`$t *)(copyin(arg0, sizeof (pid$pid\`$t)));
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    copyinstr((uintptr_t)this->t->zi_gamename), this->t->zi_ndungeons,
+	    copyinstr((uintptr_t)this->t->zi_villain), this->t->zi_haszelda);
+	next = 1;
+}
+
+pid$pid::has_dungeons:entry
+/next == 1/
+{
+	this->t = (pid$pid\`$t *)(copyin(arg0, sizeof (pid$pid\`$t)));
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    copyinstr((uintptr_t)this->t->zi_gamename), this->t->zi_ndungeons,
+	    copyinstr((uintptr_t)this->t->zi_villain), this->t->zi_haszelda);
+	next = 2;
+}
+
+pid$pid::has_villain:entry
+/next == 2/
+{
+	this->t = (pid$pid\`$t *)(copyin(arg0, sizeof (pid$pid\`$t)));
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    copyinstr((uintptr_t)this->t->zi_gamename), this->t->zi_ndungeons,
+	    copyinstr((uintptr_t)this->t->zi_villain), this->t->zi_haszelda);
+	exit(0);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:05.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.libtype.c	2014-01-14 20:12:05.833672700 -0500
@@ -0,0 +1,29 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 (c) Joyent, Inc. All rights reserved.
+ */
+
+/*
+ * We're linked against libc which has types, though we do not.
+ */
+#include <unistd.h>
+
+int
+main(void)
+{
+	for (;;) {
+		sleep(1000);
+	}
+	/*NOTREACHED*/
+	return (0);
+}
--- /dev/null	2014-01-14 20:12:06.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.libtype.ksh	2014-01-14 20:12:06.049970630 -0500
@@ -0,0 +1,45 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# Here we want to make sure that the program in question does not have ctf data
+# in its a.out; however, we can get types out of a linked libc.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="int"
+exe="tst.libtype.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -eq 0 ]]; then
+	echo "CTF exists in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+rc=`$dtrace -n "BEGIN{ trace((pid$pid\`$t)0); exit(0); }"`
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:06.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.linkmap.ksh	2014-01-14 20:12:06.340290518 -0500
@@ -0,0 +1,44 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# We should be able to see both strstr from libc and from ld on an
+# alternate linkmap.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+
+$dtrace -q -p $$ -s /dev/stdin  <<EOF
+pid\$target:LM1\`ld.so.1:strstr:entry,
+pid\$target:libc.so.1:strstr:entry
+{
+	exit (0);
+}
+
+BEGIN
+{
+	exit (0);
+}
+EOF
+rc=$?
+
+exit $rc
--- /dev/null	2014-01-14 20:12:06.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.pidprint.ksh	2014-01-14 20:12:06.572628997 -0500
@@ -0,0 +1,69 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# Use print() on userland CTF types and verify we get the data we expect.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="final_fantasy_info_t"
+exe="tst.printtype.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -qs /dev/stdin <<EOF
+pid$pid::ff_getgameid:entry
+/next == 0/
+{
+	print(*args[0]);
+	printf("\n");
+	next = 1;
+}
+
+pid$pid::ff_getpartysize:entry
+/next == 1/
+{
+	print(*args[0]);
+	printf("\n");
+	next = 2;
+}
+
+pid$pid::ff_getsummons:entry
+/next == 2/
+{
+	print(*args[0]);
+	printf("\n");
+	exit(0);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:06.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.pidprinttarg.ksh	2014-01-14 20:12:06.797276558 -0500
@@ -0,0 +1,70 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# Use print() on userland CTF types and verify we get the data we
+# expect. This time, use $target to make sure that path works correctly.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="final_fantasy_info_t"
+exe="tst.printtype.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -p $pid -qs /dev/stdin <<EOF
+pid\$target::ff_getgameid:entry
+/next == 0/
+{
+	print(*args[0]);
+	printf("\n");
+	next = 1;
+}
+
+pid\$target::ff_getpartysize:entry
+/next == 1/
+{
+	print(*args[0]);
+	printf("\n");
+	next = 2;
+}
+
+pid\$target::ff_getsummons:entry
+/next == 2/
+{
+	print(*args[0]);
+	printf("\n");
+	exit(0);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:07.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.printtype.c	2014-01-14 20:12:07.032553044 -0500
@@ -0,0 +1,72 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 (c) Joyent, Inc. All rights reserved.
+ */
+
+/*
+ * The point of this is to use print() on various functions to make sure that we
+ * can print basic structures. Note that we purposefully are making sure that
+ * there are no pointers here.
+ */
+#include <unistd.h>
+
+typedef struct final_fantasy_info {
+	int ff_gameid;
+	int ff_partysize;
+	int ff_hassummons;
+} final_fantasy_info_t;
+
+static int
+ff_getgameid(final_fantasy_info_t *f)
+{
+	return (0);
+}
+
+static int
+ff_getpartysize(final_fantasy_info_t *f)
+{
+	return (0);
+}
+
+static int
+ff_getsummons(final_fantasy_info_t *f)
+{
+	return (0);
+}
+
+int
+main(void)
+{
+	final_fantasy_info_t ffiii, ffx, ffi;
+
+	ffi.ff_gameid = 1;
+	ffi.ff_partysize = 4;
+	ffi.ff_hassummons = 0;
+
+	ffiii.ff_gameid = 6;
+	ffiii.ff_partysize = 4;
+	ffiii.ff_hassummons = 1;
+
+	ffx.ff_gameid = 10;
+	ffx.ff_partysize = 3;
+	ffx.ff_hassummons = 1;
+
+	for (;;) {
+		ff_getgameid(&ffi);
+		ff_getpartysize(&ffx);
+		ff_getsummons(&ffiii);
+		sleep(1);
+	}
+	/*NOTREACHED*/
+	return (0);
+}
--- /dev/null	2014-01-14 20:12:07.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.printtype.ksh	2014-01-14 20:12:07.260776215 -0500
@@ -0,0 +1,69 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# Use print() on userland CTF types and verify we get the data we expect.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="final_fantasy_info_t"
+exe="tst.printtype.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -qs /dev/stdin <<EOF
+pid$pid::ff_getgameid:entry
+/next == 0/
+{
+	print(*(pid$pid\`$t *)(copyin(arg0, sizeof (pid$pid\`$t))));
+	printf("\n");
+	next = 1;
+}
+
+pid$pid::ff_getpartysize:entry
+/next == 1/
+{
+	print(*(pid$pid\`$t *)(copyin(arg0, sizeof (pid$pid\`$t))));
+	printf("\n");
+	next = 2;
+}
+
+pid$pid::ff_getsummons:entry
+/next == 2/
+{
+	print(*(pid$pid\`$t *)(copyin(arg0, sizeof (pid$pid\`$t))));
+	printf("\n");
+	exit(0);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:07.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.printtypetarg.ksh	2014-01-14 20:12:07.719894115 -0500
@@ -0,0 +1,70 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# Use print() on userland CTF types and verify we get the data we
+# expect. Use the pid` alias for $target.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="final_fantasy_info_t"
+exe="tst.printtype.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -p $pid -qs /dev/stdin <<EOF
+pid\$target::ff_getgameid:entry
+/next == 0/
+{
+	print(*(pid\`$t *)(copyin(arg0, sizeof (pid\`$t))));
+	printf("\n");
+	next = 1;
+}
+
+pid\$target::ff_getpartysize:entry
+/next == 1/
+{
+	print(*(pid\`$t *)(copyin(arg0, sizeof (pid\`$t))));
+	printf("\n");
+	next = 2;
+}
+
+pid\$target::ff_getsummons:entry
+/next == 2/
+{
+	print(*(pid\`$t *)(copyin(arg0, sizeof (pid\`$t))));
+	printf("\n");
+	exit(0);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
--- /dev/null	2014-01-14 20:12:07.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.userlandkey.ksh	2014-01-14 20:12:07.951296482 -0500
@@ -0,0 +1,83 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# Simple test that if we manually use the userland keyword that it
+# works.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+t="zelda_info_t"
+exe="tst.chasestrings.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -32 -qs /dev/stdin <<EOF
+typedef struct info {
+        char    *zi_gamename;
+        int     zi_ndungeons;
+        char    *zi_villain;
+        int     zi_haszelda;
+} info_t;
+
+pid$pid::has_princess:entry
+/next == 0/
+{
+	this->t = (userland info_t *)arg0;
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(this->t->zi_gamename), this->t->zi_ndungeons,
+	    stringof(this->t->zi_villain), this->t->zi_haszelda);
+	next = 1;
+}
+
+pid$pid::has_dungeons:entry
+/next == 1/
+{
+	this->t = (userland info_t *)arg0;
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(this->t->zi_gamename), this->t->zi_ndungeons,
+	    stringof(this->t->zi_villain), this->t->zi_haszelda);
+	next = 2;
+}
+
+pid$pid::has_villain:entry
+/next == 2/
+{
+	this->t = (userland info_t *)arg0;
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(this->t->zi_gamename), this->t->zi_ndungeons,
+	    stringof(this->t->zi_villain), this->t->zi_haszelda);
+	exit(0);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
